<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode"
              v-model="filter.code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kategori</label>

            <b-form-select
              v-model="filter.category"
              :options="formattedSiteDocumentCategoryOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Item</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Tipe Site Document"
              v-model="filter.item"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button
            class="btn btn-primary btn-md"
            @click="getSiteDocumentTypes(true)"
          >
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom card-stretch-fourth p-5 gutter-b">
      <div class="d-flex my-3 justify-content-start">
        <button
          class="btn btn-success btn-md"
          @click="showInputModal(null, 'Form Tambah Tipe Site Document')"
        >
          <i class="flaticon-add"></i> Tambah Tipe Site Document
        </button>
      </div>

      <div class="card-body p-0">
        <complete-table :loading="loading" :data="siteDocumentTypes">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Code</th>
              <th class="pl-7">Item</th>
              <th class="pl-7">Kategori</th>
              <th class="pl-7 text-center">Aksi</th>
            </tr>
          </template>

          <template #defaultBody="{ item: siteDocumentType, i }">
            <tr v-bind:key="i" class="border-0">
              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ siteDocumentType.code }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ siteDocumentType.item }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    siteDocumentType.category
                      ? siteDocumentType.category.name
                      : "-"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8 text-center">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="
                    showInputModal(
                      siteDocumentType,
                      'Form Ubah Tipe Site Document',
                      false
                    )
                  "
                >
                  <i class="flaticon-edit"></i>
                </a>

                <a
                  class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                  @click="showDeleteModal(siteDocumentType)"
                >
                  <i class="flaticon-delete"></i>
                </a>
              </td>
            </tr>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="input" hide-footer :title="modalTitle">
      <div class="d-block text-center">
        <form>
          <div class="row">
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Code *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Code"
                v-model="form.code"
                :disabled="!isCreate"
              ></b-form-input>
            </div>

            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Item *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Nama Tipe Site Document"
                v-model="form.item"
              ></b-form-input>
            </div>

            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Kategori *</label>

              <b-form-select
                v-model="form.category"
                :options="formattedSiteDocumentCategoryOptions"
                size="lg"
              ></b-form-select>
            </div>
          </div>
        </form>

        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            block
            @click="
              isCreate ? saveSiteDocumentType() : updateSiteDocumentType()
            "
          >
            Simpan
          </b-button>

          <b-button
            :disabled="loading"
            class="btn btn-secondary mt-0"
            block
            @click="closeInputModal"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>

    <b-modal ref="delete" hide-footer title="Warning">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Tipe Site Document Akan Dihapus</label>
          </div>
        </div>
        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            @click="deleteSiteDocumentType"
            block
          >
            Hapus
          </b-button>

          <b-button
            class="btn btn-secondary mt-0"
            block
            @click="closeDeleteModal"
            :disabled="loading"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  DELETE_SITE_DOCUMENT_TYPE,
  GET_SITE_DOCUMENT_TYPE,
  SAVE_SITE_DOCUMENT_TYPE,
  UPDATE_SITE_DOCUMENT_TYPE
} from "../../../core/services/store/site-document-type.module";
import { GET_SITE_DOCUMENT_CATEGORY } from "../../../core/services/store/site-document-category.module";

export default {
  name: "SiteDocumentType",
  components: { CompleteTable },
  data() {
    return {
      filter: {
        code: null,
        item: null,
        category: null
      },
      currentItem: null,
      modalTitle: null,
      form: {
        code: null,
        item: null,
        category: null
      },
      isCreate: true
    };
  },

  computed: {
    ...mapState({
      loading: state => state.siteDocumentType.loading,
      siteDocumentTypes: state =>
        state.siteDocumentType.siteDocumentTypes?.data,
      siteDocumentCategories: state =>
        state.siteDocumentCategory.siteDocumentCategories?.data
    }),

    formattedSiteDocumentCategoryOptions() {
      let siteDocumentCategories = [];

      if (arrayMoreThanOne(this.siteDocumentCategories)) {
        siteDocumentCategories = this.siteDocumentCategories.map(
          siteDocumentCategory => {
            return {
              value: siteDocumentCategory.code,
              text: siteDocumentCategory.name
            };
          }
        );
      }

      return [
        { value: null, text: "Pilih Kategori" },
        ...siteDocumentCategories
      ];
    }
  },

  methods: {
    showInputModal(siteDocumentType, modalTitle, isCreate = true) {
      this.currentItem = siteDocumentType;

      this.form = {
        code: siteDocumentType?.code ?? null,
        item: siteDocumentType?.item ?? null,
        category: siteDocumentType?.category?.code ?? null
      };

      this.modalTitle = modalTitle;

      this.isCreate = isCreate;

      this.$refs["input"].show();
    },

    showDeleteModal(siteDocumentType) {
      this.currentItem = siteDocumentType;

      this.$refs["delete"].show();
    },

    closeInputModal() {
      this.$refs["input"].hide();
    },

    closeDeleteModal() {
      this.$refs["delete"].hide();
    },

    getSiteDocumentTypes(filter = false) {
      if (!arrayMoreThanOne(this.siteDocumentTypes) || filter) {
        this.$store.dispatch(GET_SITE_DOCUMENT_TYPE, {
          params: {}
        });
      }
    },

    getSiteDocumentCategories() {
      if (!arrayMoreThanOne(this.siteDocumentTypes)) {
        this.$store.dispatch(GET_SITE_DOCUMENT_CATEGORY, {
          params: {}
        });
      }
    },

    deleteSiteDocumentType() {
      this.$store
        .dispatch(DELETE_SITE_DOCUMENT_TYPE, {
          code: this.currentItem?.code
        })
        .then(() => {
          this.closeDeleteModal();
        });
    },

    saveSiteDocumentType() {
      this.$store
        .dispatch(SAVE_SITE_DOCUMENT_TYPE, this.prepareForm())
        .then(() => {
          this.closeInputModal();
        });
    },

    updateSiteDocumentType() {
      this.$store
        .dispatch(UPDATE_SITE_DOCUMENT_TYPE, this.prepareForm())
        .then(() => {
          this.closeInputModal();
        });
    },

    prepareForm() {
      const category = this.formattedSiteDocumentCategoryOptions.find(
        siteDocumentCategory =>
          siteDocumentCategory?.value === this.form.category
      );

      return {
        code: this.form.code,
        item: this.form.item,
        category: {
          name: category?.text,
          code: category?.value
        }
      };
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Tipe Site Document" }]);

    this.getSiteDocumentTypes();

    this.getSiteDocumentCategories();
  }
};
</script>
